"""
******************************
 Mattie EventScripts v2.0
  Quake Sounds
      for Counter-Strike: Source

 * Description:
   Quake Sounds!


 * Install instructions:
       1. Install Mattie's EventScripts plugins:
           http://mattie.info/cs

       2. Copy and upload this script to:
           cstrike/addons/eventscripts/quake/quake.py

       3. Add the following line somewhere in autoexec.cfg:
           es_load quake

 DONT EDIT ANYTHING IN THIS FILE!!

******************************
"""

import es
import keyvalues
import playerlib
import settinglib
import gamethread

qsettings = 1
qautodownload = 1


quake = None
quake_setting = None
firstblood = 0

info = es.AddonInfo()
info.name = 'Quake Sounds'
info.version = '0.1'
info.url = 'http://addons.eventscripts.com/addons/view/quake'
info.basename = 'quake'
info.author = 'Rio'

def load():
   global quake, quake_setting
   
   es.server.cmd('es_xkeygroupload quake_sounds |quake')
   quake = keyvalues.getKeyGroup('quake_sounds')
   es.keygroupcreate('quake')
   
   if settinglib.exists('quake') == 0:
      quake_setting = settinglib.create('quake', 'Quake Settings', 'toggle')
      quake_setting.addoption('qsounds', 'Quake Sounds')
      quake_setting.addoption('qmsg', 'Quake Messages')
      quake_setting.setdefault('qsounds', 1)
      quake_setting.setdefault('qmsg', 1)
      quake_setting.addsound('ui/buttonclick.wav')

   if es.exists('saycommand', '!quake') == 0:
      es.regsaycmd('!quake', 'quake/quake_settings', 'Turn Quake Sounds on or off')

   downloadable()

def es_map_start(event_var):
   downloadable()

def downloadable():
   if int(qautodownload) == 1:
      for k in quake:
         es.stringtable('downloadables', 'sound/%s' % str(es.keygetvalue('quake_sounds', str(k.getName()), 'sound')))
   
def unload():
   es.keygroupdelete('quake_sounds')
   es.keygroupdelete('quake')
   
   settinglib.delete('quake')
   
def player_activate(event_var):
   gamethread.delayed(3, setting_announce, event_var)

def setting_announce(event_var):
   es.tell(event_var['userid'], '#multi', '#lightgreen[Quake]#green Type #lightgreen!quake#green to turn quake sounds on or off.')
   
def quake_settings():
   if qsettings == 1:
      quake_setting.send(es.getcmduserid())
   else:
      if es.getargc() >= 2:
         if es.getargv(1) == 'sounds':
            if quake_setting.get('qsounds', es.getcmduserid()) == 0:
               quake_setting.set('qsounds', True, es.getcmduserid())
               es.tell(es.getcmduserid(), '#multi', '#lightgreen[Quake]#green Quake Sounds on!')
            else:
               quake_setting.set('qsounds', False, es.getcmduserid())
               es.tell(es.getcmduserid(), '#multi', '#lightgreen[Quake]#green Quake Sounds off!')

         if es.getargv(1) == 'msg':
            if quake_setting.get('qmsg', es.getcmduserid()) == 0:
               quake_setting.set('qmsg', True, es.getcmduserid())
               es.tell(es.getcmduserid(), '#multi', '#lightgreen[Quake]#green Quake Messages on!')
            else:
               quake_setting.set('qmsg', False, es.getcmduserid())
               es.tell(es.getcmduserid(), '#multi', '#lightgreen[Quake]#green Quake Messages off!')
      else:
         es.tell(es.getcmduserid(), '#multi', '#lightgreen[Quake]#green Type #lightgreen!quake sounds#green to toggle quake sounds on or off.')
         es.tell(es.getcmduserid(), '#multi', '#lightgreen[Quake]#green Type #lightgreen!quake msg#green to toggle quake messages on or off.')
               
def round_start(event_var):
   global firstblood
   firstblood = 0
 
def player_death(event_var):
   global firstblood
   
   if es.exists('key', 'quake', event_var['attacker']) == 0:
      es.keycreate('quake', event_var['attacker'])
      es.keysetvalue('quake', event_var['attacker'], 'triggercount', 0)
      es.keysetvalue('quake', event_var['attacker'], 'hscount', 0)
      es.keysetvalue('quake', event_var['attacker'], 'tkcount', 0)
      
   if es.exists('key', 'quake', event_var['userid']) == 1:
      es.keysetvalue('quake', event_var['userid'], 'triggercount', 0)
      es.keysetvalue('quake', event_var['userid'], 'tkcount', 0)

   if event_var['es_userteam'] == event_var['es_attackerteam'] and event_var['userid'] != event_var['attacker']:
      teamkill = 1
      es.keysetvalue('quake', event_var['attacker'], 'tkcount', int(es.keygetvalue('quake', event_var['attacker'], 'tkcount')) + 1)
   else:
      teamkill = 0
      
   if int(event_var['headshot']) == 1:
      es.keysetvalue('quake', event_var['attacker'], 'hscount', int(es.keygetvalue('quake', event_var['attacker'], 'hscount')) + 1)
             
   triggercount = int(es.keygetvalue('quake', event_var['attacker'], 'triggercount')) + 1
   es.keysetvalue('quake', event_var['attacker'], 'triggercount', triggercount)
   
   if int(teamkill) == 1:
      name = quake_exists(es.keygetvalue('quake', event_var['attacker'], 'tkcount'), 0, 1)
 
   if int(event_var['headshot']) == 1:
      hscount = es.keygetvalue('quake', event_var['attacker'], 'hscount')
      if hscount > 1:
         name = quake_exists(hscount, 1, 0)
         if name == 0:
            name = quake_exists(triggercount, 0, 0)
            if name == 0:
               name = quake_exists(1, 1, 0)
      else:
         name = quake_exists(triggercount, 0, 0)
         if name == 0:
            name = quake_exists(1, 1, 0)
   else:
      name = quake_exists(triggercount, 0, 0)

   if int(teamkill) == 0 and event_var['weapon'] == 'knife':
      name = 'humiliation'
      
   if firstblood == 0:
      name = 'firstblood'
      firstblood = 1
      
   quake_sound(name, event_var['userid'], event_var['attacker'])

def round_start(event_var):
   quake_sound('prepare')

def quake_exists(trigger_count, hs=0, teamkill=0):
   name = 0

   for k in quake:
         if es.exists('keyvalue', 'quake_sounds', str(k.getName()), 'headshot') == 0:
            es.keysetvalue('quake_sounds', str(k.getName()), 'headshot', 0)
         if es.exists('keyvalue', 'quake_sounds', str(k.getName()), 'teamkill') == 0:
            es.keysetvalue('quake_sounds', str(k.getName()), 'teamkill', 0)

         if int(k['trigger_count']) == int(trigger_count) and int(k['headshot']) == int(hs) and int(k['teamkill']) == int(teamkill):
            name = str(k.getName())
            
   return name
   
def quake_sound(name, userid=0, attacker=0):
   sound = 0
   msg = 0

   if name != 0:
      if es.exists('key', 'quake_sounds', str(name)) == 1:
         sound = es.keygetvalue('quake_sounds', name, 'sound')
         mode = es.keygetvalue('quake_sounds', name, 'mode')
         visualmode = es.keygetvalue('quake_sounds', name, 'visualmode')
         msg = es.keygetvalue('quake_sounds', str(name), 'message')
         
         if msg != 0 and attacker != 0:
            msg = msg.replace("#attacker", str(es.getplayername(attacker)))
            msg = msg.replace("#user", str(es.getplayername(userid)))
         
         if mode > 0 and sound != 0:
            if int(mode) == 1:
               qplayerlist = playerlib.getPlayerList('#all')
               for k in qplayerlist:
                  if quake_setting.get('qsounds', k.userid) == 1:
                     es.playsound(int(k.userid), sound, 1)
            if int(mode) == 2:
               if quake_setting.get('qsounds', userid) == 1:
                  es.playsound(userid, sound, 1)
               if quake_setting.get('qsounds', attacker) == 1:
                  es.playsound(attacker, sound, 1)
            if int(mode) == 3:
               if quake_setting.get('qsounds', userid) == 1:
                  es.playsound(userid, sound, 1)
            if int(mode) == 4:
               if quake_setting.get('qsounds', attacker) == 1:
                  es.playsound(attacker, sound, 1)

         if visualmode > 0 and msg != 0:
            if int(visualmode) == 1:
               qplayerlist = playerlib.getPlayerList('#all')
               for k in qplayerlist:
                  if quake_setting.get('qmsg', k.userid) == 1:
                     es.toptext(k.userid, 2, '#red', msg)
            if int(visualmode)== 2:
               if quake_setting.get('qmsg', userid) == 1:
                  es.toptext(userid, 2, '#red', msg)
               if quake_setting.get('qmsg', attacker) == 1:
                  es.toptext(attacker, 2, '#red', msg)
            if int(visualmode) == 3:
               if quake_setting.get('qmsg', userid) == 1:
                  es.toptext(userid, 2, '#red', msg)
            if int(visualmode) == 4:
               if quake_setting.get('qmsg', attacker) == 1:
                  es.toptext(attacker, 2, '#red', msg)